#property indicator_separate_window
#property indicator_buffers 1
#property indicator_style1 DRAW_LINE
#property indicator_color1 Aqua
#property indicator_width1 1

#include <IndOnline.mqh>

extern int FastPeriod = 9;
extern int SlowPeriod = 55;
extern bool AutoParams = true;

int fastPeriod = 9;
int slowPeriod = 55;

double macd[];

int init() 
{
   if (AutoParams)
   {
      switch(Period())
      {
      case PERIOD_M1:
         slowPeriod = 144;                  
         break;
      case PERIOD_M5:
         slowPeriod = 144;                  
         break;
      }
   }
   else
   {
      fastPeriod = FastPeriod;
      slowPeriod = SlowPeriod;
   }
   IndicatorDigits(Digits + 2);
   SetIndexBuffer(0, macd);
   SetIndexDrawBegin(0, slowPeriod);
   string name = "M1m("+fastPeriod+","+slowPeriod+")";
   IndicatorShortName(name);
   SetIndexLabel(0, name);
   
   return (0);
}

int start() 
{
   int limit = GetLimit();

   for (int i = limit; i >= 0; i--) 
      macd[i] = 
         iMA(NULL, 0, fastPeriod, 0, MODE_LWMA, PRICE_CLOSE, i) 
         - 
         iMA(NULL, 0, slowPeriod, 0, MODE_LWMA, PRICE_CLOSE, i);
   return (0);
}