#property indicator_separate_window
#property indicator_buffers 1
#property indicator_style1 DRAW_LINE
#property indicator_color1 OrangeRed
#property indicator_width1 1

#include <IndOnline.mqh>

extern int LWMAPeriod = 9;

double lwma[];

int init() 
{
   SetIndexBuffer(0, lwma);
   SetIndexDrawBegin(0, LWMAPeriod);
   IndicatorDigits(Digits);
   string name = "M4m("+LWMAPeriod+")";
   IndicatorShortName(name);
   SetIndexLabel(0, name);
   return (0);
}

int start() 
{
   int limit = GetLimit();

   for (int i = limit; i >= 0; i--)
   {
      lwma[i] = iMA(NULL,0,LWMAPeriod,0,MODE_LWMA,PRICE_CLOSE,i);
   }
   return (0);
}

